## kakoune 0~2016.12.20.1.3a6167ae

=== src/Makefile ===
debug ?= yes
static ?= no
pedantic ?= yes

ifeq ($(debug),yes)
    CPPFLAGS += -DKAK_DEBUG
    suffix := .debug
else
    ifeq ($(debug),no)
        CXXFLAGS += -O3
        suffix := .opt
    else
        $(error debug should be either yes or no)
    endif
endif

ifeq ($(pedantic),yes)
    CXXFLAGS += -pedantic
endif

sources := $(wildcard *.cc)
objects := $(addprefix ., $(sources:.cc=$(suffix).o))
deps := $(addprefix ., $(sources:.cc=$(suffix).d))
docs := $(wildcard ../doc/manpages/*.asciidoc)
mandocs := $(docs:.asciidoc=.gz)

PREFIX ?= /usr/local
DESTDIR ?= # root dir

NCURSESW_INCLUDE ?= /usr/include/ncursesw

bindir := $(DESTDIR)$(PREFIX)/bin
sharedir := $(DESTDIR)$(PREFIX)/share/kak
docdir := $(DESTDIR)$(PREFIX)/share/doc/kak
mandir := $(DESTDIR)$(PREFIX)/share/man/man1

os := $(shell uname)

ifeq ($(os),Darwin)
    LIBS += -lncurses -lboost_regex-mt
    CPPFLAGS += -I/usr/local/opt/ncurses/include
    LDFLAGS += -L/usr/local/opt/ncurses/lib
else ifeq ($(os),FreeBSD)
    LIBS += -ltinfow -lncursesw -lboost_regex
    CPPFLAGS += -I/usr/local/include
    LDFLAGS += -L/usr/local/lib
else ifeq ($(os),Haiku)
    LIBS += -lncursesw -lboost_regex -lnetwork -lbe
else ifeq ($(os),DragonFly)
    LIBS += -lncursesw -lboost_regex
    CPPFLAGS += -I/usr/local/include
    LDFLAGS += -L/usr/local/lib
else ifneq (,$(findstring CYGWIN,$(os)))
    CPPFLAGS += -D_XOPEN_SOURCE=700
    LIBS += -lncursesw -lboost_regex -ldbghelp
else
    LIBS += -lncursesw -lboost_regex
    CPPFLAGS += -I$(NCURSESW_INCLUDE)
    LDFLAGS += -rdynamic
endif

ifeq ($(static),yes)
    LIBS += -ltinfo -lgpm
    LDFLAGS += -static -pthread
endif

CXXFLAGS += -std=gnu++11 -g -Wall -Wno-reorder -Wno-sign-compare -Wno-address

all : kak
kak : $(objects)
	$(CXX) $(LDFLAGS) $(CXXFLAGS) $(objects) $(LIBS) -o $@

-include $(deps)

.%$(suffix).o: %.cc
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MD -MP -MF $(addprefix ., $(<:.cc=$(suffix).d)) -c -o $@ $<

# Generate the man page
../doc/kak.1.gz: ../doc/kak.1.txt
	a2x --no-xmllint -f manpage $<
	gzip -f $(basename $<)

# Generate the editor's documentation pages
# Since `a2x` won't generate man pages if some sections are missing (which we don't need),
# we generate the pages, patch them and then compress them
../doc/manpages/%.gz: ../doc/manpages/%.asciidoc
	a2x --no-xmllint -f manpage $<
	sed -i -r -e "s,^\.TH .+,.TH KAKOUNE 1 \"\" \"\" \"$(basename $(notdir $<))\"," \
	-e "/^\.SH \"NAME\"/{N;d;}" $(@:.gz=.1)
	gzip -f $(@:.gz=.1)
	mv -f $(@:.gz=.1.gz) $@

check: test
test:
	cd ../test && ./run

TAGS: tags
tags:
	ctags -R
man: ../doc/kak.1.gz
doc: $(mandocs)

clean:
	rm -f .*.o .*.d

distclean: clean
	rm -f kak

installdirs:
	install	-d $(bindir) \
		$(sharedir)/rc/base	\
		$(sharedir)/rc/core	\
		$(sharedir)/rc/extra \
		$(sharedir)/colors \
		$(docdir)/manpages \
		$(mandir)

install: kak man doc installdirs
	install	-m 0755	kak	$(bindir)
	install	-m 0644	../share/kak/kakrc $(sharedir)
	install	-m 0644	../rc/base/* $(sharedir)/rc/base
	install	-m 0644	../rc/core/* $(sharedir)/rc/core
	install	-m 0644	../rc/extra/* $(sharedir)/rc/extra
	[ -e $(sharedir)/autoload ]	|| ln -s rc	$(sharedir)/autoload
	install	-m 0644	../colors/*	$(sharedir)/colors
	install	-m 0644	../README.asciidoc $(docdir)
	install	-m 0644	../doc/manpages/*.gz $(docdir)/manpages
	install	-m 0644	../doc/kak.1.gz	$(mandir)

install-strip: install
	strip -s $(bindir)/kak

uninstall:
	rm -rf $(bindir)/kak \
		$(sharedir)	\
		$(docdir) \
		$(mandir)/kak.1.gz

.PHONY: check TAGS clean distclean installdirs install install-strip uninstall
.PHONY: tags test man doc

=== debian/changelog ===
kakoune (0~2016.12.20.1.3a6167ae-2build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:57:13 +0000

kakoune (0~2016.12.20.1.3a6167ae-2) unstable; urgency=low

  * Only depend on asciidoc-base after the asciidoc package split;
    we do not build any PDF documents, so we need neither FOP nor TeX.
  * Render the README file as plain text instead of asciidoc;
    suggested by Adam Borowski <kilobyte@angband.pl>.  Build-depend on
    w3m for the conversion.
  * Add the 04-path-max patch to try to fix the build on the Hurd.
  * Add the 05-kfreebsd patch to also detect Debian GNU/kFreeBSD.
  * Add README.text to debian/clean to fix a FTBFS-twice-in-a-row bug.
  * Bring up to compliance with Debian Policy 4.1.4:
    - add the 06-doc-conditional patch and skip the documentation build
      if "nodoc" is specified in DEB_BUILD_OPTIONS or DEB_BUILD_PROFILES
    - add an autopkgtest that runs the upstream test suite
  * Point the Vcs-* URLs to salsa.debian.org.
  * Use my Debian e-mail address as maintainer.
  * Add another typo fix.
  * Bump the debhelper compatibility level to 11 with no changes.
  * Add "Rules-Requires-Root: no" to the source control stanza.
  * Let dpkg-buildflags take care of the LFS compiler and linker flags.

 -- Peter Pentchev <roam@debian.org>  Sun, 13 May 2018 01:54:44 +0300

kakoune (0~2016.12.20.1.3a6167ae-1) unstable; urgency=low

  * Initial release.  Closes: #848400

 -- Peter Pentchev <roam@ringlet.net>  Wed, 21 Dec 2016 18:24:33 +0200

=== debian/control ===
Source: kakoune
Section: editors
Priority: optional
Build-Depends:
 debhelper (>= 11~),
 asciidoc-base,
 docbook-xsl,
 libboost-regex-dev (>= 1.50),
 libncursesw5-dev,
 xsltproc,
 w3m
Maintainer: Peter Pentchev <roam@debian.org>
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/debian/kakoune/
Vcs-Git: https://salsa.debian.org/debian/kakoune.git
Homepage: http://kakoune.org/
Rules-Requires-Root: no

Package: kakoune
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Vim-inspired, selection-oriented code editor
 Kakoune is a code editor heavily inspired by Vim; as such most of its
 commands are similar to vi’s ones, and it shares Vi’s "keystrokes as
 a text editing language" model.  Kakoune can operate in two modes, normal
 and insertion.  In insertion mode, keys are directly inserted into
 the current buffer.  In normal mode, keys are used to manipulate
 the current selection and to enter insertion mode.  Kakoune has a strong
 focus on interactivity, most commands provide immediate and incremental
 results, while still being competitive (as in keystroke count) with Vim.
 Kakoune works on selections, which are oriented, inclusive range of
 characters; selections have an anchor and a cursor character.
 Most commands move both of them, except when extending selection where
 the anchor character stays fixed and the cursor one moves around.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs

# Make sure the build environment does not accidentally affect
# the src/Makefile settings
debug=yes
static=no
pedantic=yes
PREFIX=/usr
NCURSESW_INCLUDE=/usr/include/ncursesw

export debug static pedantic PREFIX NCURSESW_INCLUDE

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
DEB_NODOC=0
else
DEB_NODOC=1
endif

override_dh_auto_test:
	env LC_ALL=C.UTF-8 dh_auto_test

ifeq (${DEB_NODOC},0)
override_dh_auto_build:
	dh_auto_build -D src -- all man doc
else
override_dh_auto_install:
	dh_auto_install -D src -- INSTALL_TARGETS='install-kak'
endif

%:
	dh '$@' -D src

=== debian/tests/control ===
Test-Command: cp /usr/bin/kak src/ && cd test/ && ./run
Depends: @, diffutils

## kakoune 2019.01.20

=== src/Makefile ===
debug ?= yes
static ?= no
gzip_man ?= yes

ifneq ($(gzip_man),yes)
    ifneq ($(gzip_man),no)
        $(error gzip_man should be either yes or no)
    endif
endif

ifeq ($(debug),yes)
    CPPFLAGS += -DKAK_DEBUG
    suffix := .debug
else
    ifeq ($(debug),no)
        CXXFLAGS += -O3
        suffix := .opt
    else
        $(error debug should be either yes or no)
    endif
endif

ifneq (,$(findstring address,$(sanitize)))
    CPPFLAGS += -fsanitize=address
    LDFLAGS += -lasan
    sanitize_suffix := $(sanitize_suffix)a
endif
ifneq (,$(findstring undefined,$(sanitize)))
    CPPFLAGS += -fsanitize=undefined
    LDFLAGS += -lubsan
    sanitize_suffix := $(sanitize_suffix)u
endif

ifneq (,$(sanitize_suffix))
    suffix := $(suffix).san_$(sanitize_suffix)
endif

version ?= $(shell if [ -f .version ]; then cat .version; elif  [ -d ../.git ]; then git describe --tags HEAD; else echo "unknown"; fi)

sources := $(sort $(wildcard *.cc))
objects := $(addprefix ., $(sources:.cc=$(suffix).o))
deps := $(addprefix ., $(sources:.cc=$(suffix).d))

PKG_CONFIG ?= $(shell command -v pkg-config 2>/dev/null)

ifeq ($(static),yes)
    PKG_CONFIG_FLAGS += --static
    LDFLAGS += -static -pthread
endif

PREFIX ?= /usr/local
DESTDIR ?= # root dir

bindir := $(DESTDIR)$(PREFIX)/bin
sharedir := $(DESTDIR)$(PREFIX)/share/kak
docdir := $(DESTDIR)$(PREFIX)/share/doc/kak
mandir := $(DESTDIR)$(PREFIX)/share/man/man1

os := $(shell uname)

ifeq ($(os),Darwin)
    LIBS += -lncurses
    CPPFLAGS += -I$(PREFIX)/opt/ncurses/include -I/opt/local/include
    LDFLAGS += -L$(PREFIX)/opt/ncurses/lib -L/opt/local/lib
else ifeq ($(os),FreeBSD)
    LIBS += -ltinfow -lncursesw
    CPPFLAGS += -I/usr/local/include
    LDFLAGS += -L/usr/local/lib
else ifeq ($(os),Haiku)
    LIBS += -lncursesw -lnetwork -lbe
else ifeq ($(os),OpenBSD)
    LIBS += -lncursesw
    CPPFLAGS += -D'KAK_BIN_PATH="$(bindir)/kak"' -I/usr/local/include
    LDFLAGS += -L/usr/local/lib
else ifneq (,$(findstring CYGWIN,$(os)))
    CPPFLAGS += -D_XOPEN_SOURCE=700
    LIBS += -lncursesw -ldbghelp
else
    ifeq ($(PKG_CONFIG),)
    	$(error "pkg-config not found in PATH")
    endif

    LIBS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --libs ncursesw)
    CPPFLAGS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --cflags ncursesw)
    LDFLAGS += -rdynamic
endif

CXXFLAGS += -pedantic -std=gnu++14 -g -Wall -Wextra -Wno-unused-parameter -Wno-reorder -Wno-sign-compare -Wno-address -Wno-noexcept-type -Wno-unknown-attributes -Wno-unknown-warning-option

all : kak

kak : kak$(suffix)
	ln -sf $< $@

kak$(suffix) : $(objects) .version.o
	$(CXX) $(LDFLAGS) $(CXXFLAGS) $(objects) .version.o $(LIBS) -o $@

-include $(deps)

.%$(suffix).o: %.cc
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MD -MP -MF $(addprefix ., $(<:.cc=$(suffix).d)) -c -o $@ $<

.version.o: .version.cc
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

.version.cc: FORCE
	@printf "%s" 'namespace Kakoune { const char* version = "$(version)"; }' > .version.cc.tmp
	@if cmp -s .version.cc.tmp .version.cc; then rm .version.cc.tmp; else mv .version.cc.tmp .version.cc; fi

# Generate the man page
ifeq ($(gzip_man),yes)
../doc/kak.1.gz: ../doc/kak.1
	gzip -n -9 -f -k $<
man: ../doc/kak.1.gz
else
man: ../doc/kak.1
endif

check: test
test: kak
	cd ../test && ./run

TAGS: tags
tags:
	ctags -R

clean:
	rm -f .*.o .*.d

dist:
	@if ! [ -d ../.git ]; then echo "make dist can only run from a git repo";  false; fi
	@if git status -s | grep -qEv '^\?\?'; then echo "working tree is not clean";  false; fi
	cd ../;                                                                   \
	basename="kakoune-$$(echo "$(version)" | sed -e s/^v//)";                 \
	git archive --format=tar --prefix=$${basename}/ HEAD -o $${basename}.tar; \
	echo "$(version)" > src/.version;                                         \
	tar --transform "s,^,$${basename}/," -rf $${basename}.tar src/.version;   \
	rm src/.version;                                                          \
	bzip2 $${basename}.tar;

distclean: clean
	rm -f kak kak$(suffix)
	find ../doc -type f \( -name \*\\.gz -o -name \*\\.1 \) -exec rm -f '{}' +

installdirs:
	install -d $(bindir) \
		$(sharedir)/rc/base \
		$(sharedir)/rc/core \
		$(sharedir)/rc/extra \
		$(sharedir)/colors \
		$(sharedir)/doc \
		$(docdir) \
		$(mandir)

install: kak man installdirs
	install -m 0755 kak $(bindir)
	install -m 0644 ../share/kak/kakrc $(sharedir)
	install -m 0644 ../doc/pages/*.asciidoc $(sharedir)/doc
	install -m 0644 ../rc/base/* $(sharedir)/rc/base
	install -m 0644 ../rc/core/* $(sharedir)/rc/core
	install -m 0644 ../rc/extra/* $(sharedir)/rc/extra
	[ -e $(sharedir)/autoload ] || ln -s rc $(sharedir)/autoload
	install -m 0644 ../colors/* $(sharedir)/colors
	install -m 0644 ../README.asciidoc $(docdir)
ifeq ($(gzip_man),yes)
	install -m 0644 ../doc/kak.1.gz $(mandir)
else
	install -m 0644 ../doc/kak.1 $(mandir)
endif

install-strip: install
	strip -s $(bindir)/kak

uninstall:
	rm -rf $(bindir)/kak \
		$(sharedir) \
		$(docdir) \
		$(mandir)/kak.1.gz \
		$(mandir)/kak.1

.PHONY: check TAGS clean dist distclean installdirs install install-strip uninstall
.PHONY: tags test man kak FORCE

=== debian/changelog ===
kakoune (2019.01.20-2) unstable; urgency=medium

  * Switch to a DEP-14 debian/master branch.
  * Use the test-name autopkgtest feature.

 -- Peter Pentchev <roam@debian.org>  Thu, 28 Feb 2019 11:27:06 +0200

kakoune (2019.01.20-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.3.0 with no changes.
  * Bump the debhelper compatibility level to 12 with no changes.
  * Add a trivial git-buildpackage config file.
  * New upstream release:
    - refresh the patches
    - add a NEWS blurb about the "auto_complete" option being
      renamed to "autocomplete"

 -- Peter Pentchev <roam@debian.org>  Wed, 23 Jan 2019 16:20:29 +0200

kakoune (2018.10.27-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.2.1 with no changes.
  * Use the B-D: debhelper-compat (= 11) mechanism.
  * Add a trivial autopkgtest running adequate on the binary package.
  * Fill in the watch file now that there have been some upstream releases.
  * New upstream release (Closes: #895578):
    - drop most changes from the 01-typos patch, mostly integrated upstream
    - drop the 02-manpages patch, only install the kak(1) manual page now;
      the rest are only installed in asciidoc format in /usr/share/kak/doc
    - drop the 06-doc-conditional patches, overtaken by upstream changes
    - refresh the line numbers in the remaining patches
    - add pkg-config as a build dependency
    - make sure doc/kak.1 is not removed during clean-up
    - the "doc" target is gone from src/Makefile, do not invoke it
    - the doc path seems to be fixed now, Closes: #895605
  * Register kak(1) as an alternative for /usr/bin/editor.  Closes: #875286

 -- Peter Pentchev <roam@debian.org>  Sun, 16 Dec 2018 18:48:07 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,16 @@
 Section: editors
 Priority: optional
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 12),
  asciidoc-base,
  docbook-xsl,
  libboost-regex-dev (>= 1.50),
  libncursesw5-dev,
+ pkg-config,
  xsltproc,
  w3m
 Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/

=== debian/rules ===
--- 
+++ 
@@ -23,11 +23,14 @@
 
 ifeq (${DEB_NODOC},0)
 override_dh_auto_build:
-	dh_auto_build -D src -- all man doc
+	dh_auto_build -D src -- all man
 else
 override_dh_auto_install:
 	dh_auto_install -D src -- INSTALL_TARGETS='install-kak'
 endif
 
+override_dh_auto_clean:
+	[ ! -f src/Makefile ] || ${MAKE} -C src clean
+
 %:
 	dh '$@' -D src

=== debian/tests/control ===
Test-Command: cp /usr/bin/kak src/ && cd test/ && ./run
Depends: @, diffutils
Features: test-name=upstream

Test-Command: adequate kakoune
Depends: @, adequate
Features: test-name=adequate

## kakoune 2019.07.01

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-debug ?= yes
+debug ?= no
 static ?= no
 gzip_man ?= yes
 
@@ -10,6 +10,7 @@
 
 ifeq ($(debug),yes)
     CPPFLAGS += -DKAK_DEBUG
+    CXXFLAGS += -Og
     suffix := .debug
 else
     ifeq ($(debug),no)
@@ -60,7 +61,8 @@
 
 ifeq ($(os),Darwin)
     LIBS += -lncurses
-    CPPFLAGS += -I$(PREFIX)/opt/ncurses/include -I/opt/local/include
+    NCURSES_CFLAGS += -I$(PREFIX)/opt/ncurses/include 
+    CPPFLAGS += -I/opt/local/include
     LDFLAGS += -L$(PREFIX)/opt/ncurses/lib -L/opt/local/lib
 else ifeq ($(os),FreeBSD)
     LIBS += -ltinfow -lncursesw
@@ -72,6 +74,7 @@
     LIBS += -lncursesw
     CPPFLAGS += -D'KAK_BIN_PATH="$(bindir)/kak"' -I/usr/local/include
     LDFLAGS += -L/usr/local/lib
+    mandir := $(DESTDIR)$(PREFIX)/man/man1
 else ifneq (,$(findstring CYGWIN,$(os)))
     CPPFLAGS += -D_XOPEN_SOURCE=700
     LIBS += -lncursesw -ldbghelp
@@ -81,11 +84,11 @@
     endif
 
     LIBS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --libs ncursesw)
-    CPPFLAGS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --cflags ncursesw)
+    NCURSES_CFLAGS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --cflags ncursesw)
     LDFLAGS += -rdynamic
 endif
 
-CXXFLAGS += -pedantic -std=gnu++14 -g -Wall -Wextra -Wno-unused-parameter -Wno-reorder -Wno-sign-compare -Wno-address -Wno-noexcept-type -Wno-unknown-attributes -Wno-unknown-warning-option
+CXXFLAGS += -pedantic -std=c++17 -g -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare -Wno-address
 
 all : kak
 
@@ -100,6 +103,8 @@
 .%$(suffix).o: %.cc
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MD -MP -MF $(addprefix ., $(<:.cc=$(suffix).d)) -c -o $@ $<
 
+.ncurses_ui$(suffix).o: CPPFLAGS += $(NCURSES_CFLAGS)
+
 .version.o: .version.cc
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<
 
@@ -110,7 +115,7 @@
 # Generate the man page
 ifeq ($(gzip_man),yes)
 ../doc/kak.1.gz: ../doc/kak.1
-	gzip -n -9 -f -k $<
+	gzip -n -9 -f < $< > $@
 man: ../doc/kak.1.gz
 else
 man: ../doc/kak.1
@@ -144,9 +149,7 @@
 
 installdirs:
 	install -d $(bindir) \
-		$(sharedir)/rc/base \
-		$(sharedir)/rc/core \
-		$(sharedir)/rc/extra \
+		$(sharedir)/rc \
 		$(sharedir)/colors \
 		$(sharedir)/doc \
 		$(docdir) \
@@ -156,9 +159,8 @@
 	install -m 0755 kak $(bindir)
 	install -m 0644 ../share/kak/kakrc $(sharedir)
 	install -m 0644 ../doc/pages/*.asciidoc $(sharedir)/doc
-	install -m 0644 ../rc/base/* $(sharedir)/rc/base
-	install -m 0644 ../rc/core/* $(sharedir)/rc/core
-	install -m 0644 ../rc/extra/* $(sharedir)/rc/extra
+	cp -r ../rc/* $(sharedir)/rc
+	find $(sharedir)/rc -type f -exec chmod 0644 {} +
 	[ -e $(sharedir)/autoload ] || ln -s rc $(sharedir)/autoload
 	install -m 0644 ../colors/* $(sharedir)/colors
 	install -m 0644 ../README.asciidoc $(docdir)

=== debian/changelog ===
kakoune (2019.07.01-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:44:46 +0100

kakoune (2019.07.01-1) unstable; urgency=medium

  * Mark the adequate autopkgtest as superficial.
  * Declare compliance with Debian Policy 4.4.1 with no changes.
  * Drop the version from the libboost-regex-dev build dependency,
    satisfied even in oldstable (stretch).
  * New upstream version:
    - update the line numbers in the patches
  * Drop nodoc handling for now, pending more extensive changes to
    the upstream build system.
  * Correct some more typographical errors.

 -- Peter Pentchev <roam@debian.org>  Sun, 06 Oct 2019 19:33:26 +0300

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
  debhelper-compat (= 12),
  asciidoc-base,
  docbook-xsl,
- libboost-regex-dev (>= 1.50),
+ libboost-regex-dev,
  libncursesw5-dev,
  pkg-config,
  xsltproc,
  w3m
 Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/

=== debian/rules ===
--- 
+++ 
@@ -12,22 +12,11 @@
 
 export debug static pedantic PREFIX NCURSESW_INCLUDE
 
-ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
-DEB_NODOC=0
-else
-DEB_NODOC=1
-endif
-
 override_dh_auto_test:
 	env LC_ALL=C.UTF-8 dh_auto_test
 
-ifeq (${DEB_NODOC},0)
 override_dh_auto_build:
 	dh_auto_build -D src -- all man
-else
-override_dh_auto_install:
-	dh_auto_install -D src -- INSTALL_TARGETS='install-kak'
-endif
 
 override_dh_auto_clean:
 	[ ! -f src/Makefile ] || ${MAKE} -C src clean

=== debian/tests/control ===
--- 
+++ 
@@ -5,3 +5,4 @@
 Test-Command: adequate kakoune
 Depends: @, adequate
 Features: test-name=adequate
+Restrictions: superficial

## kakoune 2020.01.16

=== src/Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
 debug ?= no
 static ?= no
 gzip_man ?= yes
+# to get format compatible with GitHub archive use "gzip -S .gz" here
+compress_bin ?= bzip2
 
 ifneq ($(gzip_man),yes)
     ifneq ($(gzip_man),no)
@@ -10,7 +12,7 @@
 
 ifeq ($(debug),yes)
     CPPFLAGS += -DKAK_DEBUG
-    CXXFLAGS += -Og
+    CXXFLAGS += -O0
     suffix := .debug
 else
     ifeq ($(debug),no)
@@ -22,12 +24,12 @@
 endif
 
 ifneq (,$(findstring address,$(sanitize)))
-    CPPFLAGS += -fsanitize=address
+    CXXFLAGS += -fsanitize=address
     LDFLAGS += -lasan
     sanitize_suffix := $(sanitize_suffix)a
 endif
 ifneq (,$(findstring undefined,$(sanitize)))
-    CPPFLAGS += -fsanitize=undefined
+    CXXFLAGS += -fsanitize=undefined
     LDFLAGS += -lubsan
     sanitize_suffix := $(sanitize_suffix)u
 endif
@@ -90,6 +92,13 @@
 
 CXXFLAGS += -pedantic -std=c++17 -g -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare -Wno-address
 
+compiler := $(shell $(CXX) --version)
+ifneq (,$(findstring clang,$(compiler)))
+    CXXFLAGS += -frelaxed-template-template-args
+else ifneq (,$(findstring GCC,$(compiler)))
+    CXXFLAGS += -Wno-init-list-lifetime
+endif
+
 all : kak
 
 kak : kak$(suffix)
@@ -141,7 +150,7 @@
 	echo "$(version)" > src/.version;                                         \
 	tar --transform "s,^,$${basename}/," -rf $${basename}.tar src/.version;   \
 	rm src/.version;                                                          \
-	bzip2 $${basename}.tar;
+	$(compress_bin) $${basename}.tar;
 
 distclean: clean
 	rm -f kak kak$(suffix)

=== debian/changelog ===
kakoune (2020.01.16-3) unstable; urgency=medium

  * Add the 13-upstream-check-dir-owner and 14-upstream-rework-dir-logic
    patches from the upstream Git repository to stop kakoune started as
    root from making its runtime directory inaccessible to the normal
    user account of the session user. Closes: #990635

 -- Peter Pentchev <roam@debian.org>  Mon, 05 Jul 2021 22:15:28 +0300

kakoune (2020.01.16-2) unstable; urgency=medium

  * Add some files to debian/clean to allow kakoune to be built twice in
    a row.
  * Add several upstream patches:
    - 09-upstream-test-buffer
    - 10-upstream-empty-strings
    - 11-upstream-deleted-line
    - 12-upstream-empty-register
  * Use debian/kakoune.alternatives to make use of debhelper 13.1's
    dh_installalternatives helper.
  * Correct another typographical error.

 -- Peter Pentchev <roam@debian.org>  Sun, 26 Jul 2020 01:56:44 +0300

kakoune (2020.01.16-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.5.0 with no changes.
  * Drop the adequate autopkgtest.
  * Drop the Name and Contact upstream metadata fields.
  * New upstream version:
    - add the 08-optimize patch to not pass -O0 to the compiler,
      thus also restoring the build hardening functionality
  * Bump the debhelper compat level to 13 with no changes.
  * Drop "-D/-C src" from the rules file now there is a top-level Makefile.

 -- Peter Pentchev <roam@debian.org>  Wed, 29 Apr 2020 21:32:22 +0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: editors
 Priority: optional
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper (>> 13.1~),
+ debhelper-compat (= 13),
  asciidoc-base,
  docbook-xsl,
  libboost-regex-dev,
@@ -11,7 +12,7 @@
  xsltproc,
  w3m
 Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/

=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,10 @@
 	env LC_ALL=C.UTF-8 dh_auto_test
 
 override_dh_auto_build:
-	dh_auto_build -D src -- all man
+	dh_auto_build -- all man
 
 override_dh_auto_clean:
-	[ ! -f src/Makefile ] || ${MAKE} -C src clean
+	[ ! -f src/Makefile ] || ${MAKE} clean
 
 %:
-	dh '$@' -D src
+	dh '$@'

=== debian/tests/control ===
Test-Command: cp /usr/bin/kak src/ && cd test/ && ./run
Depends: @, diffutils
Features: test-name=upstream

## kakoune 2020.09.01

=== src/Makefile ===
--- 
+++ 
@@ -95,7 +95,7 @@
 compiler := $(shell $(CXX) --version)
 ifneq (,$(findstring clang,$(compiler)))
     CXXFLAGS += -frelaxed-template-template-args
-else ifneq (,$(findstring GCC,$(compiler)))
+else ifneq (,$(findstring g++,$(compiler)))
     CXXFLAGS += -Wno-init-list-lifetime
 endif
 
@@ -139,7 +139,7 @@
 	ctags -R
 
 clean:
-	rm -f .*.o .*.d
+	rm -f $(objects) $(deps)
 
 dist:
 	@if ! [ -d ../.git ]; then echo "make dist can only run from a git repo";  false; fi

=== debian/changelog ===
kakoune (2020.09.01-3) unstable; urgency=medium

  * Use the C++ gnu::packed attribute in the 16-sizeof-struct patch as
    suggested by the upstream author.
  * Add the 17-hurd-executable patch to fix the FTBFS on the Hurd.

 -- Peter Pentchev <roam@debian.org>  Sat, 21 Aug 2021 17:38:49 +0300

kakoune (2020.09.01-2) unstable; urgency=medium

  * Add the 16-sizeof-struct patch to fix the m68k FTBFS due to
    the padding and alignment of members of a structure.

 -- Peter Pentchev <roam@debian.org>  Sat, 21 Aug 2021 02:43:46 +0300

kakoune (2020.09.01-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.6.0 with no changes.
  * New upstream release:
    - drop the 09-upstream-test-buffer, 10-upstream-empty-strings,
      11-upstream-deleted-line, and 12-upstream-empty-register patches;
      they were obtained from the upstream source
    - add another correction to the 01-typos patch
    - update the line numbers in the patches
  * Add the 15-upstream-limits to fix the build with GCC 11. Closes: #984075

 -- Peter Pentchev <roam@debian.org>  Thu, 19 Aug 2021 17:18:11 +0300

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  xsltproc,
  w3m
 Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/

## kakoune 2021.11.08

=== src/Makefile ===
--- 
+++ 
@@ -44,10 +44,7 @@
 objects := $(addprefix ., $(sources:.cc=$(suffix).o))
 deps := $(addprefix ., $(sources:.cc=$(suffix).d))
 
-PKG_CONFIG ?= $(shell command -v pkg-config 2>/dev/null)
-
 ifeq ($(static),yes)
-    PKG_CONFIG_FLAGS += --static
     LDFLAGS += -static -pthread
 endif
 
@@ -55,6 +52,7 @@
 DESTDIR ?= # root dir
 
 bindir := $(DESTDIR)$(PREFIX)/bin
+libexecdir := $(DESTDIR)$(PREFIX)/libexec/kak
 sharedir := $(DESTDIR)$(PREFIX)/share/kak
 docdir := $(DESTDIR)$(PREFIX)/share/doc/kak
 mandir := $(DESTDIR)$(PREFIX)/share/man/man1
@@ -62,31 +60,24 @@
 os := $(shell uname)
 
 ifeq ($(os),Darwin)
-    LIBS += -lncurses
-    NCURSES_CFLAGS += -I$(PREFIX)/opt/ncurses/include 
     CPPFLAGS += -I/opt/local/include
-    LDFLAGS += -L$(PREFIX)/opt/ncurses/lib -L/opt/local/lib
+    LDFLAGS += -L/opt/local/lib
 else ifeq ($(os),FreeBSD)
-    LIBS += -ltinfow -lncursesw
     CPPFLAGS += -I/usr/local/include
     LDFLAGS += -L/usr/local/lib
 else ifeq ($(os),Haiku)
-    LIBS += -lncursesw -lnetwork -lbe
+    LIBS += -lnetwork -lbe
 else ifeq ($(os),OpenBSD)
-    LIBS += -lncursesw
     CPPFLAGS += -D'KAK_BIN_PATH="$(bindir)/kak"' -I/usr/local/include
     LDFLAGS += -L/usr/local/lib
     mandir := $(DESTDIR)$(PREFIX)/man/man1
-else ifneq (,$(findstring CYGWIN,$(os)))
+else ifneq (,$(findstring _NT,$(os)))
+    # Both Cygwin and MSYS2 have "_NT" in their uname.
     CPPFLAGS += -D_XOPEN_SOURCE=700
-    LIBS += -lncursesw -ldbghelp
+    LIBS += -ldbghelp
+else ifeq ($(os),SunOS)
+    LDFLAGS += -lsocket -rdynamic
 else
-    ifeq ($(PKG_CONFIG),)
-    	$(error "pkg-config not found in PATH")
-    endif
-
-    LIBS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --libs ncursesw)
-    NCURSES_CFLAGS += $(shell $(PKG_CONFIG) $(PKG_CONFIG_FLAGS) --cflags ncursesw)
     LDFLAGS += -rdynamic
 endif
 
@@ -111,8 +102,6 @@
 
 .%$(suffix).o: %.cc
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MD -MP -MF $(addprefix ., $(<:.cc=$(suffix).d)) -c -o $@ $<
-
-.ncurses_ui$(suffix).o: CPPFLAGS += $(NCURSES_CFLAGS)
 
 .version.o: .version.cc
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<
@@ -158,6 +147,7 @@
 
 installdirs:
 	install -d $(bindir) \
+		$(libexecdir) \
 		$(sharedir)/rc \
 		$(sharedir)/colors \
 		$(sharedir)/doc \
@@ -166,6 +156,7 @@
 
 install: kak man installdirs
 	install -m 0755 kak $(bindir)
+	ln -sf ../../bin/kak $(libexecdir)/kak
 	install -m 0644 ../share/kak/kakrc $(sharedir)
 	install -m 0644 ../doc/pages/*.asciidoc $(sharedir)/doc
 	cp -r ../rc/* $(sharedir)/rc
@@ -184,6 +175,7 @@
 
 uninstall:
 	rm -rf $(bindir)/kak \
+		$(libexecdir) \
 		$(sharedir) \
 		$(docdir) \
 		$(mandir)/kak.1.gz \

=== debian/changelog ===
kakoune (2021.11.08-2) unstable; urgency=medium

  * Add the murmurhash-endian patch to fix the build on s390x.
    Closes: #1011978
  * Add the iterator and validate-alpha patches to fix the build with GCC 12.
    Closes: #1012956
  * Declare compliance with Policy 4.6.1 with no changes.

 -- Peter Pentchev <roam@debian.org>  Fri, 24 Jun 2022 20:23:47 +0300

kakoune (2021.11.08-1) unstable; urgency=medium

  * Use a comma, not a semicolon, after "upstream" in patch Origin lines.
  * Explicitly depend on dh-sequence-single-binary.
  * New upstream version:
    - add a couple of new corrections to the 01-typos patch
    - drop the 13-upstream-check-dir-owner, 14-upstream-rework-dir-logic, and
      15-upstream-limits patches, they were taken from upstream commits
    - drop the 16-sizeof-struct and 17-hurd-executable patches,
      applied upstream
    - refresh the patch line numbers

 -- Peter Pentchev <roam@debian.org>  Sun, 27 Feb 2022 17:00:26 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Build-Depends:
  debhelper (>> 13.1~),
  debhelper-compat (= 13),
+ dh-sequence-single-binary,
  asciidoc-base,
  docbook-xsl,
  libboost-regex-dev,
@@ -12,7 +13,7 @@
  xsltproc,
  w3m
 Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/

## kakoune 2022.10.31

=== Makefile ===
all:
	$(MAKE) -C src $@

%: FORCE
	$(MAKE) -C src $@

.PHONY: all FORCE

=== src/Makefile ===
--- 
+++ 
@@ -81,11 +81,11 @@
     LDFLAGS += -rdynamic
 endif
 
-CXXFLAGS += -pedantic -std=c++17 -g -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare -Wno-address
+CXXFLAGS += -pedantic -std=c++2a -g -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare -Wno-address
 
 compiler := $(shell $(CXX) --version)
 ifneq (,$(findstring clang,$(compiler)))
-    CXXFLAGS += -frelaxed-template-template-args
+    CXXFLAGS += -frelaxed-template-template-args -Wno-ambiguous-reversed-operator
 else ifneq (,$(findstring g++,$(compiler)))
     CXXFLAGS += -Wno-init-list-lifetime
 endif
@@ -128,7 +128,7 @@
 	ctags -R
 
 clean:
-	rm -f $(objects) $(deps)
+	rm -f $(objects) $(deps) .version.cc .version.o
 
 dist:
 	@if ! [ -d ../.git ]; then echo "make dist can only run from a git repo";  false; fi
@@ -153,6 +153,9 @@
 		$(sharedir)/doc \
 		$(docdir) \
 		$(mandir)
+ifeq ($(debug),yes)
+	install -d $(sharedir)/gdb
+endif
 
 install: kak man installdirs
 	install -m 0755 kak $(bindir)
@@ -169,6 +172,9 @@
 else
 	install -m 0644 ../doc/kak.1 $(mandir)
 endif
+ifeq ($(debug),yes)
+	install -m 0644 ../gdb/kakoune.py $(sharedir)/gdb
+endif
 
 install-strip: install
 	strip -s $(bindir)/kak

=== debian/changelog ===
kakoune (2022.10.31-2) unstable; urgency=medium

  * Switch the ncurses build dependency from the transitional
    libncursesw5-dev package to libncurses-dev.
  * Add the 09-gcc-13, 10-gcc-13-warnings, and 11-gcc-13-types upstream
    patches to fix the build with GCC 13. Closes: #1037705

 -- Peter Pentchev <roam@debian.org>  Fri, 16 Jun 2023 12:48:38 +0300

kakoune (2022.10.31-1) unstable; urgency=medium

  * Declare compliance with Policy 4.6.2 with no changes.
  * New upstream version:
    - drop the murmurhash-endian patch, integrated upstream slightly differently
    - drop the iterator and validate-alpha patches, taken from upstream
    - adapt the typos patch
    - refresh line numbers in the rest of the patches

 -- Peter Pentchev <roam@debian.org>  Sat, 07 Jan 2023 00:44:48 +0200

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,12 @@
  asciidoc-base,
  docbook-xsl,
  libboost-regex-dev,
- libncursesw5-dev,
+ libncurses-dev,
  pkg-config,
  xsltproc,
  w3m
 Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/

## kakoune 2024.05.18

=== Makefile ===
.POSIX:
.SUFFIXES:

CXX = c++

debug = no
static = no
gzip_man = yes
# to get format compatible with GitHub archive use "gzip -S .gz" here
compress_bin = bzip2

compress-suffix-bzip2 = bz2
compress-suffix-zstd = zst

CPPFLAGS-debug-yes = -DKAK_DEBUG
CXXFLAGS-debug-yes = -O0 -g3
tag-debug-yes = .debug

CXXFLAGS-debug-no = -O3 -g3
tag-debug-no = .opt

CXXFLAGS-sanitize-address = -fsanitize=address
LDFLAGS-sanitize-address = -lasan
tag-sanitize-address = .san_a

CXXFLAGS-sanitize-undefined = -fsanitize=undefined

LDFLAGS-sanitize-undefined = -lubsan
tag-sanitize-undefined = .san_u

LDFLAGS-static-yes = -static -pthread

version = $(shell cat .version 2>/dev/null || git describe --tags HEAD 2>/dev/null | sed s/^v// || echo unknown)
version != cat .version 2>/dev/null || ( git describe --tags HEAD 2>/dev/null | sed s/^v// ) || echo unknown

PREFIX = /usr/local
DESTDIR = # root dir

bindir = $(DESTDIR)$(PREFIX)/bin
libexecdir = $(DESTDIR)$(PREFIX)/libexec/kak
sharedir = $(DESTDIR)$(PREFIX)/share/kak
docdir = $(DESTDIR)$(PREFIX)/share/doc/kak
mandir = $(DESTDIR)$(PREFIX)/share/man/man1

# Both Cygwin and MSYS2 have "_NT" in their uname.
os = $(shell uname | sed 's/.*_NT.*/Windows/')
os != uname | sed 's/.*_NT.*/Windows/'

CPPFLAGS-os-Darwin = -I/opt/local/include
LDFLAGS-os-Darwin = -L/opt/local/lib

CPPFLAGS-os-FreeBSD = -I/usr/local/include
LDFLAGS-os-FreeBSD = -L/usr/local/lib

LIBS-os-Haiku = -lnetwork -lbe

CPPFLAGS-os-OpenBSD = -DKAK_BIN_PATH=\"$(bindir)/kak\" -I/usr/local/include
LDFLAGS-os-OpenBSD = -L/usr/local/lib
mandir-os-OpenBSD = $(DESTDIR)$(PREFIX)/man/man1

LDFLAGS-os-SunOS = -lsocket -rdynamic

CPPFLAGS-os-Windows = -D_XOPEN_SOURCE=700
LIBS-os-Windows = -ldbghelp

CXXFLAGS-default = -std=c++2a -Wall -Wextra -pedantic -Wno-unused-parameter -Wno-sign-compare

compiler = $(shell $(CXX) --version | grep -E -o 'clang|g\+\+|c\+\+' | head -1)
compiler != $(CXX) --version | grep -E -o 'clang|g\+\+|c\+\+' | head -1
CXXFLAGS-compiler-clang = -fsized-deallocation
CXXFLAGS-compiler-g++ = -Wno-init-list-lifetime -Wno-stringop-overflow
CXXFLAGS-compiler-c++ = $(CXXFLAGS-compiler-g++)

KAK_CPPFLAGS = \
	$(CPPFLAGS-default) \
	$(CPPFLAGS-debug-$(debug)) \
	$(CPPFLAGS-os-$(os)) \
	$(CPPFLAGS)

KAK_CXXFLAGS = \
	$(CXXFLAGS-default) \
	$(CXXFLAGS-debug-$(debug)) \
	$(CXXFLAGS-sanitize-$(sanitize)) \
	$(CXXFLAGS-compiler-$(compiler)) \
	$(CXXFLAGS)

KAK_LDFLAGS = \
	$(LDFLAGS-default) \
	$(LDFLAGS-sanitize-$(sanitize)) \
	$(LDFLAGS-static-$(static)) \
	$(LDFLAGS-os-$(os)) \
	$(LDFLAGS)

KAK_LIBS = \
	$(LIBS-os-$(os)) \
	$(LIBS)

tag = $(tag-debug-$(debug))$(tag-sanitize-$(sanitize))

.SUFFIXES: $(tag).o .cc
.PHONY: src/kak

sources = $(shell find src -type f -name '*.cc' | sed -e '/\.version\.cc/d')
sources != find src -type f -name '*.cc' | sed -e '/\.version\.cc/d'
objects = $(sources:.cc=$(tag).o)

all: src/kak

src/kak: src/kak$(tag)
	ln -sf kak$(tag) $@

src/kak$(tag): src/.version.o $(objects)
	$(CXX) $(KAK_LDFLAGS) $(KAK_CXXFLAGS) $(KAK_LIBS) $(objects) src/.version.o -o $@

deps = $(shell touch src/.version$(tag).d && find src -type f -name '.*$(tag).d') # Ensure we find one deps for FreeBSD make
deps != touch src/.version$(tag).d && find src -type f -name '.*$(tag).d' # Ensure we find one deps for FreeBSD make
include $(deps)

.cc$(tag).o:
	$(CXX) $(KAK_CPPFLAGS) $(KAK_CXXFLAGS) -MD -MP -MF $(*D)/.$(*F)$(tag).d -c -o $@ $<

src/.version.cc:
	echo 'namespace Kakoune { const char *version = "$(version)"; }' > $@

src/.version.o: src/.version.cc
	$(CXX) $(KAK_CPPFLAGS) $(KAK_CXXFLAGS) -c -o $@ src/.version.cc

# Generate the man page
man: gzip-man-$(gzip_man)

gzip-man-yes: doc/kak.1.gz
gzip-man-no: doc/kak.1

doc/kak.1.gz: doc/kak.1
	gzip -n -9 -f < doc/kak.1 > $@

check: test
test: src/kak
	if [ $(os) = OpenBSD ]; then \
        	export KAKOUNE_RUNTIME=$$PWD/share/kak; \
	fi && \
	cd test && ./run

TAGS: tags
tags:
	ctags -R

clean:
	rm -f $(objects) $(deps) src/.version*

dist: kakoune-$(version).tar.$(compress-suffix-$(compress_bin))

kakoune-$(version).tar.$(compress-suffix-$(compress_bin)): kakoune-$(version).tar
	$(compress_bin) -f $<

kakoune-$(version).tar:
	@if ! [ -d .git ]; then echo "make dist can only run from a git repo";  false; fi
	@if git status -s | grep -qEv '^\?\?'; then echo "working tree is not clean";  false; fi
	git archive --format=tar --prefix=$(@:.tar=)/ HEAD -o $@
	echo "$(version)" > .version
	tar --transform "s,^,$(@:.tar=)/," -rf $@ .version
	rm -f .version

distclean: clean
	rm -f src/kak src/kak$(suffix) src/.*.d src/*.o
	find doc -type f -name '*.gz' -exec rm -f '{}' +

installdirs: installdirs-debug-$(debug)

installdirs-debug-no:
	mkdir -p \
		$(bindir) \
		$(libexecdir) \
		$(sharedir)/rc \
		$(sharedir)/colors \
		$(sharedir)/doc \
		$(docdir) \
		$(mandir)

installdirs-debug-yes: installdirs-debug-no
	mkdir -p $(sharedir)/gdb

install: src/kak installdirs install-debug-$(debug) install-gzip-man-$(gzip_man)
	cp src/kak$(suffix) $(bindir)
	chmod 0755 $(bindir)/kak

	ln -sf ../../bin/kak $(libexecdir)/kak

	cp share/kak/kakrc $(sharedir)
	chmod 0644 $(sharedir)/kakrc

	cp -r rc/* $(sharedir)/rc
	find $(sharedir)/rc -type f -exec chmod 0644 {} +
	[ -e $(sharedir)/autoload ] || ln -s rc $(sharedir)/autoload

	cp colors/* $(sharedir)/colors
	chmod 0644 $(sharedir)/colors/*

	cp README.asciidoc $(docdir)
	chmod 0644 $(docdir)/*.asciidoc
	cp doc/pages/*.asciidoc $(sharedir)/doc
	chmod 0644 $(sharedir)/doc/*.asciidoc

install-gzip-man-yes: gzip-man-yes
	cp -f doc/kak.1.gz $(mandir)
	chmod 0644 $(mandir)/kak.1.gz

install-gzip-man-no: gzip-man-no
	cp -f doc/kak.1 $(mandir)
	chmod 0644 $(mandir)/kak.1

install-debug-yes: installdirs-debug-yes
	cp -f gdb/kakoune.py $(sharedir)/gdb
	chmod 0644 $(sharedir)/gdb/kakoune.py

install-debug-no: installdirs-debug-no

install-strip: install
	strip -s $(bindir)/kak

uninstall:
	rm -rf \
		$(bindir)/kak \
		$(libexecdir) \
		$(sharedir) \
		$(docdir) \
		$(mandir)/kak.*

=== debian/changelog ===
kakoune (2024.05.18-2ubuntu1) plucky; urgency=medium

  * Add optimize=-lto to DEB_BUILD_MAINT_OPTIONS due to OOM during build

 -- Adrien Nader <adrien.nader@canonical.com>  Fri, 24 Jan 2025 14:01:34 +0100

kakoune (2024.05.18-2) unstable; urgency=medium

  * Fix FTBFS with debhelper 13.17 and later: we override dh_auto_install,
    so it is on us to pass --destdir now. Also Closes: #1080391
  * Use debputy's X-Style: black.

 -- Peter Pentchev <roam@debian.org>  Tue, 03 Sep 2024 16:47:12 +0300

kakoune (2024.05.18-1) unstable; urgency=medium

  * Declare compliance with Policy 4.7.0 with no changes.
  * Use debhelper compat level 14 and X-DH-Compat.
  * Let debhelper take care of some default dependencies.
  * Use dpkg's default.mk for completeness.
  * Declare dpkg-build-api v1, drop the implied Rules-Requires-Root: no.
  * Use dh-package-notes to record ELF package metadata.
  * New upstream version:
    - refresh the 01-typos and 05-kfreebsd patches
    - chase the upstream move of most of the targets from src/Makefile to
      the top-level Makefile in the 03-readmei and 08-optimize patches
    - drop the 09-gcc-13, 10-gcc-13-warnings, and 11-gcc-13-types patches,
      they were taken from upstream
    - pass the override variables on the make(1) command line instead of
      via the environment
    - add the 09-parallel-dirs patch to fix installation with -jN
  * Drop the libboost-regex-dev, ncurses, and pkg-config build dependencies;
    Kakoune has not used either ncurses or boost-regex for some time now.
  * Reorder some targets in the rules file for clarity.

 -- Peter Pentchev <roam@debian.org>  Sun, 28 Jul 2024 18:33:11 +0300

=== debian/control ===
--- 
+++ 
@@ -2,29 +2,26 @@
 Section: editors
 Priority: optional
 Build-Depends:
- debhelper (>> 13.1~),
- debhelper-compat (= 13),
+ asciidoc-base,
+ debhelper (>> 13.15.2~),
+ dh-package-notes,
  dh-sequence-single-binary,
- asciidoc-base,
  docbook-xsl,
- libboost-regex-dev,
- libncurses-dev,
- pkg-config,
+ dpkg-build-api (= 1),
+ w3m,
  xsltproc,
- w3m
-Maintainer: Peter Pentchev <roam@debian.org>
-Standards-Version: 4.6.2
+X-DH-Compat: 14
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Peter Pentchev <roam@debian.org>
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/kakoune/
 Vcs-Git: https://salsa.debian.org/debian/kakoune.git
 Homepage: http://kakoune.org/
-Rules-Requires-Root: no
+X-Style: black
 
 Package: kakoune
 Architecture: any
 Multi-Arch: foreign
-Depends:
- ${shlibs:Depends},
- ${misc:Depends}
 Description: Vim-inspired, selection-oriented code editor
  Kakoune is a code editor heavily inspired by Vim; as such most of its
  commands are similar to vi’s ones, and it shares Vi’s "keystrokes as

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto

include /usr/share/dpkg/default.mk

include /usr/share/debhelper/dh_package_notes/package-notes.mk

# Override some of the Makefile settings
make_overrides = \
	debug=yes \
	static=no \
	pedantic=yes \
	PREFIX=/usr \

override_dh_auto_build:
	dh_auto_build -- all man $(make_overrides)

override_dh_auto_install:
	dh_auto_install --destdir '$(CURDIR)/debian/kakoune' -- $(make_overrides)

override_dh_auto_test:
	env LC_ALL=C.UTF-8 dh_auto_test -- $(make_overrides)

override_dh_auto_clean:
	[ ! -f src/Makefile ] || ${MAKE} clean

%:
	dh '$@'

=== debian/tests/control ===
Test-Command: cp /usr/bin/kak src/ && cd test/ && ./run
Depends:
 diffutils,
 @,
Features:
 test-name=upstream,
